import PySide6
from PySide6.QtCore import QFile, QIODevice
from PySide6.QtUiTools import QUiLoader
from PySide6.QtWidgets import QApplication

import sys

# Base source: https://doc.qt.io/qt-6/designer-using-a-ui-file-python.html
def load_ui(filename: str) -> tuple[PySide6.QtWidgets.QWidget, QApplication]:
    app = QApplication(sys.argv)
    ui_file = QFile(filename)
    if not ui_file.open(QIODevice.ReadOnly):
        print("Cannot open {}: {}".format(filename, ui_file.errorString()))
        sys.exit(-1)

    loader = QUiLoader()
    widget = loader.load(ui_file, None)
    ui_file.close()

    if not widget:
        print(loader.errorString())
        sys.exit(-1)

    return widget, app


if __name__ == '__main__':
    widget, app = load_ui('ui/ControllerUI/currents.ui')
    widget.show()

    print(widget)

    sys.exit(app.exec())
